#include <iostream>
#include <vector>

struct TrieNode {
    std::vector < TrieNode * > letter;

    TrieNode ( ) : letter ( 10 ) {
        for ( int i = 0; i < 10; i ++ ) { letter [ i ] = nullptr; }
    }

    ~TrieNode ( ) {
        for ( int i = 0; i < 10; i ++ ) {
            delete letter [ i ];
        }
    }

    void add ( const std::string & s ) {
        TrieNode * node = this;
        for ( const auto & c: s ) {
            if ( ! node -> letter [ c - '0' ] ) {
                node -> letter [ c - '0' ] = new TrieNode;
            }
            node = node -> letter [ c - '0' ];
        }
    }

    int findStar ( const std::string & s, int depth ) {
        TrieNode * node = this;
        int count = 0;
        for ( ; depth < 9; depth ++ ) {
            for ( int j = 0; j < 10; j ++ ) {
                if ( node -> letter [ j ] ) { count += findStar ( std::string ( s, depth + 1 ), depth + 1 ); }
            }
        }


        return count;
    }

    int search ( const std::string & s, int depth = 0 ) {
        TrieNode * node = this;
        int count = 0;

        for ( int i = depth; i < 10; i ++ ) {
            if ( s [ i ] == '?' ) {
                for ( int j = 0; j < 10; j ++ ) {
                    if ( node -> letter [ j ] ) {
                        count += node -> letter [ j ] -> search ( std::string ( s, i + 1 ) );
                    }
                }
                break;
            }
            else if ( s [ i ] == '*' ) {
                count += findStar ( std::string ( s, i + 1 ), i + 1 );
            }
            else if ( node -> letter [ s [ i ] - '0' ] ) {
                if ( i == 9 ) { count ++; }
                else {
                    node = node -> letter [ s [ i ] - '0' ];
                }
            }
            else { break; }
        }
        return count;
    }

};

int main ( ) {
    TrieNode * trie = new TrieNode ( );
    int n;
    std::cin >> n;
    for ( int i = 0; i < n; i ++ ) {
        std::string s;
        std::cin >> s;
        trie -> add( s );
    }

    std::cin >> n;
    for ( int i = 0; i < n; i ++ ) {
        std::string s;
        std::cin >> s;
        std::cout << trie -> search ( s ) << std::endl;
    }
    delete trie;
}